Bug 171707 - Include Julian Anastasov's kernel patches for dual wan routing
Include Julian Anastasov's kernel patches for dual wan routing
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dave Jones
Brian Brock
: FutureFeature
Depends On:
  Show dependency treegraph
Reported: 2005-10-25 10:00 EDT by James Dinkel
Modified: 2015-01-04 17:22 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2005-10-25 16:35:26 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Julian's patches for multi-gateway routers (34.32 KB, patch)
2005-10-25 10:00 EDT, James Dinkel
no flags Details | Diff

  None (edit)
Description James Dinkel 2005-10-25 10:00:17 EDT
Description of problem:
I would like for Julian Anastasov's kernel patches to be integrated into the 
stock kernel (or, if possible, as a kernel module installable via yum?).  The 
kernel patches can be found here: http://www.ssi.bg/~ja/#routes-2.6

As a related feature: also modify the network scripts, so when, say a gateway 
is defined in ifcfg-eth0 and a gateway is defined in ifcfg-eth1, the rules are 
setup according to the 
instructions "http://www.linuxquestions.org/questions/answers.php?
action=viewarticle&artid=490" (some more info also 
at "http://lartc.org/howto/lartc.rpdb.multiple-links.html")

Basically, the network script change is to set up rules to allow the router to 
use both gateways for internet access, but it causes problems if one gateway 
goes down.  That is where Julian's kernel patches come in.  The patches allow 
better dead gateway detection, so if one gateway goes down then all traffic is 
sent to the other gateway and (somehow, I don't know how) when the downed 
gateway comes back, it is automatically detected and traffic is again sent to 
that gateway.

Version-Release number of selected component (if applicable):

How reproducible: always

Steps to Reproduce:
1. Configure a router with multiple interfaces connected to internet gateways
2. add GATEWAY=blah.blah.blah.blah to the appropriate ifcfg-ethX for each 
3. run traceroutes to various sites on the net
4. break the connection to one gateway, to see failover
Actual results:
At step 3, all traceroutes show the traffic going over the same interface

At step 4, if the gateway is lost that all traffic from step 3 is going over, 
then all internet traffic is lost.  After setting up the correct ip route 
rules manually, then when one gateway is lost all traffic that would be sent 
to that gateway is lost and does not failover to the next gateway.

Expected results:
At step 3, each traceroute to a different site should go over a different 
gateway in sequential order.

At step 4, when one gateway is unreachable, that gateway is skipped and 
traffic goes to the next gateway until the unreachable gateway is detected as 
available again.

Additional info:
As I said, Julian Anastasov already did all the hard work.  I just wish his 
patches were in the stock kernels (or available as an addon via yum) so I can 
have the router automatically update with yum without breaking.  Modifying the 
scripts should be a trivial task, it's just running a few extra "ip route add" 
and "ip rule add" commands using variables already in the ifcfg-ethX files.
Comment 1 James Dinkel 2005-10-25 10:00:18 EDT
Created attachment 120353 [details]
Julian's patches for multi-gateway routers
Comment 2 Dave Jones 2005-10-25 16:35:26 EDT
needs to be merged upstream.  netdev@vger.kernel.org
Comment 3 James Dinkel 2005-10-26 09:20:38 EDT
Fedora includes other patches to the kernel (so I've heard).  It would be 
advantageous to have this one.  Also, aren't the network scripts completely 
specific to Fedora/Redhat?  If the network scripts need to be filed under a 
different component, could you let me know which one...
Comment 4 Dave Jones 2005-10-27 19:27:01 EDT
whilst we do carry some patches, we try to the limit 'new feature' style patches
where possible. Every added patch is an increased maintainence burden, so where
I can, I'm dropping patches instead of adding more.

network scripts would be 'initscripts' component at a guess.
Comment 5 James Dinkel 2005-10-28 11:39:53 EDT
Ok, I understand, and thanks for the reply.  I'll file the network scripts 
changes under initscripts (they will still be advantageous even without 
Julian's patches) and cross my fingers.  I've also filed a bug report with 
kernel.org (don't know if they want feature requests or not).  I really can't 
imagine this not EVER getting included.  Routing and firewalling seems to be 
one of the more popular things to do with linux and dual wan connections are 
becoming ever more popular...

Note You need to log in before you can comment on or make changes to this bug.